/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
grammar InternalDispatching;

options {
	superClass=AbstractInternalContentAssistParser;
	backtrack=true;
}

@lexer::header {
package org.eclipse.lsat.dispatching.teditor.ide.contentassist.antlr.internal;

// Hack: Use our own Lexer superclass by means of import. 
// Currently there is no other way to specify the superclass for the lexer.
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.Lexer;
}

@parser::header {
package org.eclipse.lsat.dispatching.teditor.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.lsat.dispatching.teditor.services.DispatchingGrammarAccess;

}
@parser::members {
	private DispatchingGrammarAccess grammarAccess;

	public void setGrammarAccess(DispatchingGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}

	@Override
	protected Grammar getGrammar() {
		return grammarAccess.getGrammar();
	}

	@Override
	protected String getValueForTokenName(String tokenName) {
		return tokenName;
	}
}

// Entry rule entryRuleActivityDispatching
entryRuleActivityDispatching
:
{ before(grammarAccess.getActivityDispatchingRule()); }
	 ruleActivityDispatching
{ after(grammarAccess.getActivityDispatchingRule()); } 
	 EOF 
;

// Rule ActivityDispatching
ruleActivityDispatching 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getActivityDispatchingAccess().getGroup()); }
		(rule__ActivityDispatching__Group__0)
		{ after(grammarAccess.getActivityDispatchingAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceIterationsMapEntry
entryRuleResourceIterationsMapEntry
:
{ before(grammarAccess.getResourceIterationsMapEntryRule()); }
	 ruleResourceIterationsMapEntry
{ after(grammarAccess.getResourceIterationsMapEntryRule()); } 
	 EOF 
;

// Rule ResourceIterationsMapEntry
ruleResourceIterationsMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceIterationsMapEntryAccess().getGroup()); }
		(rule__ResourceIterationsMapEntry__Group__0)
		{ after(grammarAccess.getResourceIterationsMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDispatchGroup
entryRuleDispatchGroup
:
{ before(grammarAccess.getDispatchGroupRule()); }
	 ruleDispatchGroup
{ after(grammarAccess.getDispatchGroupRule()); } 
	 EOF 
;

// Rule DispatchGroup
ruleDispatchGroup 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getGroup()); }
		(rule__DispatchGroup__Group__0)
		{ after(grammarAccess.getDispatchGroupAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleNumberRepeats
entryRuleNumberRepeats
:
{ before(grammarAccess.getNumberRepeatsRule()); }
	 ruleNumberRepeats
{ after(grammarAccess.getNumberRepeatsRule()); } 
	 EOF 
;

// Rule NumberRepeats
ruleNumberRepeats 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getNumberRepeatsAccess().getGroup()); }
		(rule__NumberRepeats__Group__0)
		{ after(grammarAccess.getNumberRepeatsAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleRange
entryRuleRange
:
{ before(grammarAccess.getRangeRule()); }
	 ruleRange
{ after(grammarAccess.getRangeRule()); } 
	 EOF 
;

// Rule Range
ruleRange 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getRangeAccess().getGroup()); }
		(rule__Range__Group__0)
		{ after(grammarAccess.getRangeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceYieldMapEntry
entryRuleResourceYieldMapEntry
:
{ before(grammarAccess.getResourceYieldMapEntryRule()); }
	 ruleResourceYieldMapEntry
{ after(grammarAccess.getResourceYieldMapEntryRule()); } 
	 EOF 
;

// Rule ResourceYieldMapEntry
ruleResourceYieldMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceYieldMapEntryAccess().getGroup()); }
		(rule__ResourceYieldMapEntry__Group__0)
		{ after(grammarAccess.getResourceYieldMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleAttribute
entryRuleAttribute
:
{ before(grammarAccess.getAttributeRule()); }
	 ruleAttribute
{ after(grammarAccess.getAttributeRule()); } 
	 EOF 
;

// Rule Attribute
ruleAttribute 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getAttributeAccess().getGroup()); }
		(rule__Attribute__Group__0)
		{ after(grammarAccess.getAttributeAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleDispatch
entryRuleDispatch
:
{ before(grammarAccess.getDispatchRule()); }
	 ruleDispatch
{ after(grammarAccess.getDispatchRule()); } 
	 EOF 
;

// Rule Dispatch
ruleDispatch 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getDispatchAccess().getGroup()); }
		(rule__Dispatch__Group__0)
		{ after(grammarAccess.getDispatchAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleAttributesMapEntry
entryRuleAttributesMapEntry
:
{ before(grammarAccess.getAttributesMapEntryRule()); }
	 ruleAttributesMapEntry
{ after(grammarAccess.getAttributesMapEntryRule()); } 
	 EOF 
;

// Rule AttributesMapEntry
ruleAttributesMapEntry 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getGroup()); }
		(rule__AttributesMapEntry__Group__0)
		{ after(grammarAccess.getAttributesMapEntryAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleImport
entryRuleImport
:
{ before(grammarAccess.getImportRule()); }
	 ruleImport
{ after(grammarAccess.getImportRule()); } 
	 EOF 
;

// Rule Import
ruleImport 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getImportAccess().getGroup()); }
		(rule__Import__Group__0)
		{ after(grammarAccess.getImportAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleEBigDecimal
entryRuleEBigDecimal
:
{ before(grammarAccess.getEBigDecimalRule()); }
	 ruleEBigDecimal
{ after(grammarAccess.getEBigDecimalRule()); } 
	 EOF 
;

// Rule EBigDecimal
ruleEBigDecimal 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getEBigDecimalAccess().getGroup()); }
		(rule__EBigDecimal__Group__0)
		{ after(grammarAccess.getEBigDecimalAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleIDString
entryRuleIDString
:
{ before(grammarAccess.getIDStringRule()); }
	 ruleIDString
{ after(grammarAccess.getIDStringRule()); } 
	 EOF 
;

// Rule IDString
ruleIDString 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getIDStringAccess().getAlternatives()); }
		(rule__IDString__Alternatives)
		{ after(grammarAccess.getIDStringAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleINTASString
entryRuleINTASString
:
{ before(grammarAccess.getINTASStringRule()); }
	 ruleINTASString
{ after(grammarAccess.getINTASStringRule()); } 
	 EOF 
;

// Rule INTASString
ruleINTASString 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getINTASStringAccess().getINTTerminalRuleCall()); }
		RULE_INT
		{ after(grammarAccess.getINTASStringAccess().getINTTerminalRuleCall()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleIID
entryRuleIID
:
{ before(grammarAccess.getIIDRule()); }
	 ruleIID
{ after(grammarAccess.getIIDRule()); } 
	 EOF 
;

// Rule IID
ruleIID 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getIIDAccess().getAlternatives()); }
		(rule__IID__Alternatives)
		{ after(grammarAccess.getIIDAccess().getAlternatives()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceQualifiedName
entryRuleResourceQualifiedName
:
{ before(grammarAccess.getResourceQualifiedNameRule()); }
	 ruleResourceQualifiedName
{ after(grammarAccess.getResourceQualifiedNameRule()); } 
	 EOF 
;

// Rule ResourceQualifiedName
ruleResourceQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
		(rule__ResourceQualifiedName__Group__0)
		{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

// Entry rule entryRuleResourceItemQualifiedName
entryRuleResourceItemQualifiedName
:
{ before(grammarAccess.getResourceItemQualifiedNameRule()); }
	 ruleResourceItemQualifiedName
{ after(grammarAccess.getResourceItemQualifiedNameRule()); } 
	 EOF 
;

// Rule ResourceItemQualifiedName
ruleResourceItemQualifiedName 
	@init {
		int stackSize = keepStackSize();
	}
	:
	(
		{ before(grammarAccess.getResourceItemQualifiedNameAccess().getGroup()); }
		(rule__ResourceItemQualifiedName__Group__0)
		{ after(grammarAccess.getResourceItemQualifiedNameAccess().getGroup()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Alternatives_4_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_0()); }
		(rule__DispatchGroup__RepeatsAssignment_4_3_0)
		{ after(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_0()); }
	)
	|
	(
		{ before(grammarAccess.getDispatchGroupAccess().getGroup_4_3_1()); }
		(rule__DispatchGroup__Group_4_3_1__0)
		{ after(grammarAccess.getDispatchGroupAccess().getGroup_4_3_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Alternatives_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRangeAccess().getStartAssignment_1_0()); }
		(rule__Range__StartAssignment_1_0)
		{ after(grammarAccess.getRangeAccess().getStartAssignment_1_0()); }
	)
	|
	(
		{ before(grammarAccess.getRangeAccess().getGroup_1_1()); }
		(rule__Range__Group_1_1__0)
		{ after(grammarAccess.getRangeAccess().getGroup_1_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Alternatives_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getColonKeyword_2_0()); }
		(':')
		{ after(grammarAccess.getAttributesMapEntryAccess().getColonKeyword_2_0()); }
	)
	|
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getEqualsSignKeyword_2_1()); }
		'='
		{ after(grammarAccess.getAttributesMapEntryAccess().getEqualsSignKeyword_2_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__ValueAlternatives_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getValueIDStringParserRuleCall_3_0_0()); }
		ruleIDString
		{ after(grammarAccess.getAttributesMapEntryAccess().getValueIDStringParserRuleCall_3_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getValueINTASStringParserRuleCall_3_0_1()); }
		ruleINTASString
		{ after(grammarAccess.getAttributesMapEntryAccess().getValueINTASStringParserRuleCall_3_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Alternatives_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0()); }
		'E'
		{ after(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_0()); }
	)
	|
	(
		{ before(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1()); }
		'e'
		{ after(grammarAccess.getEBigDecimalAccess().getEKeyword_3_0_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__IDString__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getIDStringAccess().getIDTerminalRuleCall_0()); }
		RULE_ID
		{ after(grammarAccess.getIDStringAccess().getIDTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getIDStringAccess().getSTRINGTerminalRuleCall_1()); }
		RULE_STRING
		{ after(grammarAccess.getIDStringAccess().getSTRINGTerminalRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__IID__Alternatives
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
		RULE_INT
		{ after(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); }
	)
	|
	(
		{ before(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
		RULE_ID
		{ after(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group__0__Impl
	rule__ActivityDispatching__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getActivityDispatchingAction_0()); }
	()
	{ after(grammarAccess.getActivityDispatchingAccess().getActivityDispatchingAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group__1__Impl
	rule__ActivityDispatching__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getImportsAssignment_1()); }
	(rule__ActivityDispatching__ImportsAssignment_1)*
	{ after(grammarAccess.getActivityDispatchingAccess().getImportsAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group__2__Impl
	rule__ActivityDispatching__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getGroup_2()); }
	(rule__ActivityDispatching__Group_2__0)?
	{ after(grammarAccess.getActivityDispatchingAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getDispatchGroupsAssignment_3()); }
	(rule__ActivityDispatching__DispatchGroupsAssignment_3)*
	{ after(grammarAccess.getActivityDispatchingAccess().getDispatchGroupsAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ActivityDispatching__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2__0__Impl
	rule__ActivityDispatching__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getThroughputKeyword_2_0()); }
	'throughput'
	{ after(grammarAccess.getActivityDispatchingAccess().getThroughputKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2__1__Impl
	rule__ActivityDispatching__Group_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getLeftCurlyBracketKeyword_2_1()); }
	'{'
	{ after(grammarAccess.getActivityDispatchingAccess().getLeftCurlyBracketKeyword_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2__2__Impl
	rule__ActivityDispatching__Group_2__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getGroup_2_2()); }
	(rule__ActivityDispatching__Group_2_2__0)?
	{ after(grammarAccess.getActivityDispatchingAccess().getGroup_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2__3__Impl
	rule__ActivityDispatching__Group_2__4
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getResourceIterationsAssignment_2_3()); }
	(rule__ActivityDispatching__ResourceIterationsAssignment_2_3)*
	{ after(grammarAccess.getActivityDispatchingAccess().getResourceIterationsAssignment_2_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getRightCurlyBracketKeyword_2_4()); }
	'}'
	{ after(grammarAccess.getActivityDispatchingAccess().getRightCurlyBracketKeyword_2_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ActivityDispatching__Group_2_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2_2__0__Impl
	rule__ActivityDispatching__Group_2_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getIterationsKeyword_2_2_0()); }
	'iterations'
	{ after(grammarAccess.getActivityDispatchingAccess().getIterationsKeyword_2_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2_2__1__Impl
	rule__ActivityDispatching__Group_2_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getColonKeyword_2_2_1()); }
	':'
	{ after(grammarAccess.getActivityDispatchingAccess().getColonKeyword_2_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ActivityDispatching__Group_2_2__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__Group_2_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getActivityDispatchingAccess().getNumberOfIterationsAssignment_2_2_2()); }
	(rule__ActivityDispatching__NumberOfIterationsAssignment_2_2_2)
	{ after(grammarAccess.getActivityDispatchingAccess().getNumberOfIterationsAssignment_2_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceIterationsMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceIterationsMapEntry__Group__0__Impl
	rule__ResourceIterationsMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceIterationsMapEntryAccess().getIterationsKeyword_0()); }
	'iterations'
	{ after(grammarAccess.getResourceIterationsMapEntryAccess().getIterationsKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceIterationsMapEntry__Group__1__Impl
	rule__ResourceIterationsMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceIterationsMapEntryAccess().getFullStopKeyword_1()); }
	'.'
	{ after(grammarAccess.getResourceIterationsMapEntryAccess().getFullStopKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceIterationsMapEntry__Group__2__Impl
	rule__ResourceIterationsMapEntry__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceIterationsMapEntryAccess().getKeyAssignment_2()); }
	(rule__ResourceIterationsMapEntry__KeyAssignment_2)
	{ after(grammarAccess.getResourceIterationsMapEntryAccess().getKeyAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceIterationsMapEntry__Group__3__Impl
	rule__ResourceIterationsMapEntry__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceIterationsMapEntryAccess().getColonKeyword_3()); }
	':'
	{ after(grammarAccess.getResourceIterationsMapEntryAccess().getColonKeyword_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceIterationsMapEntry__Group__4__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceIterationsMapEntryAccess().getValueAssignment_4()); }
	(rule__ResourceIterationsMapEntry__ValueAssignment_4)
	{ after(grammarAccess.getResourceIterationsMapEntryAccess().getValueAssignment_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__0__Impl
	rule__DispatchGroup__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getDispatchGroupAction_0()); }
	()
	{ after(grammarAccess.getDispatchGroupAccess().getDispatchGroupAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__1__Impl
	rule__DispatchGroup__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getActivitiesKeyword_1()); }
	'activities'
	{ after(grammarAccess.getDispatchGroupAccess().getActivitiesKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__2__Impl
	rule__DispatchGroup__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getNameAssignment_2()); }
	(rule__DispatchGroup__NameAssignment_2)?
	{ after(grammarAccess.getDispatchGroupAccess().getNameAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__3__Impl
	rule__DispatchGroup__Group__4
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_3()); }
	(rule__DispatchGroup__Group_3__0)?
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__4
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__4__Impl
	rule__DispatchGroup__Group__5
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__4__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_4()); }
	(rule__DispatchGroup__Group_4__0)?
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_4()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__5
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__5__Impl
	rule__DispatchGroup__Group__6
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__5__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getLeftCurlyBracketKeyword_5()); }
	'{'
	{ after(grammarAccess.getDispatchGroupAccess().getLeftCurlyBracketKeyword_5()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__6
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__6__Impl
	rule__DispatchGroup__Group__7
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__6__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_6()); }
	(rule__DispatchGroup__Group_6__0)?
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_6()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__7
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__7__Impl
	rule__DispatchGroup__Group__8
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__7__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getResourceYieldAssignment_7()); }
	(rule__DispatchGroup__ResourceYieldAssignment_7)*
	{ after(grammarAccess.getDispatchGroupAccess().getResourceYieldAssignment_7()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__8
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__8__Impl
	rule__DispatchGroup__Group__9
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__8__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_8()); }
	(rule__DispatchGroup__Group_8__0)?
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_8()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__9
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__9__Impl
	rule__DispatchGroup__Group__10
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__9__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getDispatchesAssignment_9()); }
	(rule__DispatchGroup__DispatchesAssignment_9)*
	{ after(grammarAccess.getDispatchGroupAccess().getDispatchesAssignment_9()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__10
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group__10__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group__10__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRightCurlyBracketKeyword_10()); }
	'}'
	{ after(grammarAccess.getDispatchGroupAccess().getRightCurlyBracketKeyword_10()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3__0__Impl
	rule__DispatchGroup__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getLeftParenthesisKeyword_3_0()); }
	'('
	{ after(grammarAccess.getDispatchGroupAccess().getLeftParenthesisKeyword_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3__1__Impl
	rule__DispatchGroup__Group_3__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_3_1()); }
	(rule__DispatchGroup__Group_3_1__0)?
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRightParenthesisKeyword_3_2()); }
	')'
	{ after(grammarAccess.getDispatchGroupAccess().getRightParenthesisKeyword_3_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3_1__0__Impl
	rule__DispatchGroup__Group_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getUserAttributesAssignment_3_1_0()); }
	(rule__DispatchGroup__UserAttributesAssignment_3_1_0)
	{ after(grammarAccess.getDispatchGroupAccess().getUserAttributesAssignment_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_3_1_1()); }
	(rule__DispatchGroup__Group_3_1_1__0)*
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_3_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3_1_1__0__Impl
	rule__DispatchGroup__Group_3_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getCommaKeyword_3_1_1_0()); }
	','
	{ after(grammarAccess.getDispatchGroupAccess().getCommaKeyword_3_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_3_1_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_3_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getUserAttributesAssignment_3_1_1_1()); }
	(rule__DispatchGroup__UserAttributesAssignment_3_1_1_1)
	{ after(grammarAccess.getDispatchGroupAccess().getUserAttributesAssignment_3_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_4__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4__0__Impl
	rule__DispatchGroup__Group_4__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRepeatKeyword_4_0()); }
	'repeat'
	{ after(grammarAccess.getDispatchGroupAccess().getRepeatKeyword_4_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4__1__Impl
	rule__DispatchGroup__Group_4__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getIteratorNameAssignment_4_1()); }
	(rule__DispatchGroup__IteratorNameAssignment_4_1)?
	{ after(grammarAccess.getDispatchGroupAccess().getIteratorNameAssignment_4_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4__2__Impl
	rule__DispatchGroup__Group_4__3
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getColonKeyword_4_2()); }
	':'
	{ after(grammarAccess.getDispatchGroupAccess().getColonKeyword_4_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getAlternatives_4_3()); }
	(rule__DispatchGroup__Alternatives_4_3)
	{ after(grammarAccess.getDispatchGroupAccess().getAlternatives_4_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_4_3_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1__0__Impl
	rule__DispatchGroup__Group_4_3_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getLeftSquareBracketKeyword_4_3_1_0()); }
	'['
	{ after(grammarAccess.getDispatchGroupAccess().getLeftSquareBracketKeyword_4_3_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1__1__Impl
	rule__DispatchGroup__Group_4_3_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_1_1()); }
	(rule__DispatchGroup__RepeatsAssignment_4_3_1_1)
	{ after(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1__2__Impl
	rule__DispatchGroup__Group_4_3_1__3
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getGroup_4_3_1_2()); }
	(rule__DispatchGroup__Group_4_3_1_2__0)*
	{ after(grammarAccess.getDispatchGroupAccess().getGroup_4_3_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRightSquareBracketKeyword_4_3_1_3()); }
	']'
	{ after(grammarAccess.getDispatchGroupAccess().getRightSquareBracketKeyword_4_3_1_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_4_3_1_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1_2__0__Impl
	rule__DispatchGroup__Group_4_3_1_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getCommaKeyword_4_3_1_2_0()); }
	','
	{ after(grammarAccess.getDispatchGroupAccess().getCommaKeyword_4_3_1_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_4_3_1_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_4_3_1_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_1_2_1()); }
	(rule__DispatchGroup__RepeatsAssignment_4_3_1_2_1)
	{ after(grammarAccess.getDispatchGroupAccess().getRepeatsAssignment_4_3_1_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_6__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_6__0__Impl
	rule__DispatchGroup__Group_6__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_6__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getYieldKeyword_6_0()); }
	'yield'
	{ after(grammarAccess.getDispatchGroupAccess().getYieldKeyword_6_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_6__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_6__1__Impl
	rule__DispatchGroup__Group_6__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_6__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getColonKeyword_6_1()); }
	':'
	{ after(grammarAccess.getDispatchGroupAccess().getColonKeyword_6_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_6__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_6__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_6__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getYieldAssignment_6_2()); }
	(rule__DispatchGroup__YieldAssignment_6_2)
	{ after(grammarAccess.getDispatchGroupAccess().getYieldAssignment_6_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__DispatchGroup__Group_8__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_8__0__Impl
	rule__DispatchGroup__Group_8__1
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_8__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getOffsetKeyword_8_0()); }
	'offset'
	{ after(grammarAccess.getDispatchGroupAccess().getOffsetKeyword_8_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_8__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_8__1__Impl
	rule__DispatchGroup__Group_8__2
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_8__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getColonKeyword_8_1()); }
	':'
	{ after(grammarAccess.getDispatchGroupAccess().getColonKeyword_8_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_8__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__DispatchGroup__Group_8__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__Group_8__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchGroupAccess().getOffsetAssignment_8_2()); }
	(rule__DispatchGroup__OffsetAssignment_8_2)
	{ after(grammarAccess.getDispatchGroupAccess().getOffsetAssignment_8_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__NumberRepeats__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NumberRepeats__Group__0__Impl
	rule__NumberRepeats__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__NumberRepeats__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNumberRepeatsAccess().getRepeatAction_0()); }
	()
	{ after(grammarAccess.getNumberRepeatsAccess().getRepeatAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__NumberRepeats__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__NumberRepeats__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__NumberRepeats__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getNumberRepeatsAccess().getNumRepeatsAssignment_1()); }
	(rule__NumberRepeats__NumRepeatsAssignment_1)
	{ after(grammarAccess.getNumberRepeatsAccess().getNumRepeatsAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Range__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Range__Group__0__Impl
	rule__Range__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRangeAccess().getRepeatAction_0()); }
	()
	{ after(grammarAccess.getRangeAccess().getRepeatAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Range__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRangeAccess().getAlternatives_1()); }
	(rule__Range__Alternatives_1)
	{ after(grammarAccess.getRangeAccess().getAlternatives_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Range__Group_1_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Range__Group_1_1__0__Impl
	rule__Range__Group_1_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group_1_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRangeAccess().getStartAssignment_1_1_0()); }
	(rule__Range__StartAssignment_1_1_0)
	{ after(grammarAccess.getRangeAccess().getStartAssignment_1_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group_1_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Range__Group_1_1__1__Impl
	rule__Range__Group_1_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group_1_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRangeAccess().getFullStopFullStopKeyword_1_1_1()); }
	'..'
	{ after(grammarAccess.getRangeAccess().getFullStopFullStopKeyword_1_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group_1_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Range__Group_1_1__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__Group_1_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getRangeAccess().getEndAssignment_1_1_2()); }
	(rule__Range__EndAssignment_1_1_2)
	{ after(grammarAccess.getRangeAccess().getEndAssignment_1_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceYieldMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceYieldMapEntry__Group__0__Impl
	rule__ResourceYieldMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceYieldMapEntryAccess().getYieldKeyword_0()); }
	'yield'
	{ after(grammarAccess.getResourceYieldMapEntryAccess().getYieldKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceYieldMapEntry__Group__1__Impl
	rule__ResourceYieldMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceYieldMapEntryAccess().getKeyAssignment_1()); }
	(rule__ResourceYieldMapEntry__KeyAssignment_1)
	{ after(grammarAccess.getResourceYieldMapEntryAccess().getKeyAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceYieldMapEntry__Group__2__Impl
	rule__ResourceYieldMapEntry__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceYieldMapEntryAccess().getColonKeyword_2()); }
	':'
	{ after(grammarAccess.getResourceYieldMapEntryAccess().getColonKeyword_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceYieldMapEntry__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceYieldMapEntryAccess().getValueAssignment_3()); }
	(rule__ResourceYieldMapEntry__ValueAssignment_3)
	{ after(grammarAccess.getResourceYieldMapEntryAccess().getValueAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Attribute__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Attribute__Group__0__Impl
	rule__Attribute__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributeAccess().getAttributeAction_0()); }
	()
	{ after(grammarAccess.getAttributeAccess().getAttributeAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Attribute__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributeAccess().getNameAssignment_1()); }
	(rule__Attribute__NameAssignment_1)
	{ after(grammarAccess.getAttributeAccess().getNameAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group__0__Impl
	rule__Dispatch__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getActivityAssignment_0()); }
	(rule__Dispatch__ActivityAssignment_0)
	{ after(grammarAccess.getDispatchAccess().getActivityAssignment_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group__1__Impl
	rule__Dispatch__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getGroup_1()); }
	(rule__Dispatch__Group_1__0)?
	{ after(grammarAccess.getDispatchAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getGroup_2()); }
	(rule__Dispatch__Group_2__0)?
	{ after(grammarAccess.getDispatchAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1__0__Impl
	rule__Dispatch__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getLeftSquareBracketKeyword_1_0()); }
	'['
	{ after(grammarAccess.getDispatchAccess().getLeftSquareBracketKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1__1__Impl
	rule__Dispatch__Group_1__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getResourceItemsAssignment_1_1()); }
	(rule__Dispatch__ResourceItemsAssignment_1_1)
	{ after(grammarAccess.getDispatchAccess().getResourceItemsAssignment_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1__2__Impl
	rule__Dispatch__Group_1__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getGroup_1_2()); }
	(rule__Dispatch__Group_1_2__0)*
	{ after(grammarAccess.getDispatchAccess().getGroup_1_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getRightSquareBracketKeyword_1_3()); }
	']'
	{ after(grammarAccess.getDispatchAccess().getRightSquareBracketKeyword_1_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group_1_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1_2__0__Impl
	rule__Dispatch__Group_1_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getCommaKeyword_1_2_0()); }
	','
	{ after(grammarAccess.getDispatchAccess().getCommaKeyword_1_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_1_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_1_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getResourceItemsAssignment_1_2_1()); }
	(rule__Dispatch__ResourceItemsAssignment_1_2_1)
	{ after(grammarAccess.getDispatchAccess().getResourceItemsAssignment_1_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2__0__Impl
	rule__Dispatch__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getLeftParenthesisKeyword_2_0()); }
	'('
	{ after(grammarAccess.getDispatchAccess().getLeftParenthesisKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2__1__Impl
	rule__Dispatch__Group_2__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getDescriptionAssignment_2_1()); }
	(rule__Dispatch__DescriptionAssignment_2_1)?
	{ after(grammarAccess.getDispatchAccess().getDescriptionAssignment_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2__2__Impl
	rule__Dispatch__Group_2__3
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getGroup_2_2()); }
	(rule__Dispatch__Group_2_2__0)?
	{ after(grammarAccess.getDispatchAccess().getGroup_2_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getRightParenthesisKeyword_2_3()); }
	')'
	{ after(grammarAccess.getDispatchAccess().getRightParenthesisKeyword_2_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group_2_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2_2__0__Impl
	rule__Dispatch__Group_2_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getUserAttributesAssignment_2_2_0()); }
	(rule__Dispatch__UserAttributesAssignment_2_2_0)
	{ after(grammarAccess.getDispatchAccess().getUserAttributesAssignment_2_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getGroup_2_2_1()); }
	(rule__Dispatch__Group_2_2_1__0)*
	{ after(grammarAccess.getDispatchAccess().getGroup_2_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Dispatch__Group_2_2_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2_2_1__0__Impl
	rule__Dispatch__Group_2_2_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getCommaKeyword_2_2_1_0()); }
	','
	{ after(grammarAccess.getDispatchAccess().getCommaKeyword_2_2_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Dispatch__Group_2_2_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__Group_2_2_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getDispatchAccess().getUserAttributesAssignment_2_2_1_1()); }
	(rule__Dispatch__UserAttributesAssignment_2_2_1_1)
	{ after(grammarAccess.getDispatchAccess().getUserAttributesAssignment_2_2_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__AttributesMapEntry__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__AttributesMapEntry__Group__0__Impl
	rule__AttributesMapEntry__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributesMapEntryAccess().getAttributesMapEntryAction_0()); }
	()
	{ after(grammarAccess.getAttributesMapEntryAccess().getAttributesMapEntryAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__AttributesMapEntry__Group__1__Impl
	rule__AttributesMapEntry__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributesMapEntryAccess().getKeyAssignment_1()); }
	(rule__AttributesMapEntry__KeyAssignment_1)
	{ after(grammarAccess.getAttributesMapEntryAccess().getKeyAssignment_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__AttributesMapEntry__Group__2__Impl
	rule__AttributesMapEntry__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributesMapEntryAccess().getAlternatives_2()); }
	(rule__AttributesMapEntry__Alternatives_2)
	{ after(grammarAccess.getAttributesMapEntryAccess().getAlternatives_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__AttributesMapEntry__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getAttributesMapEntryAccess().getValueAssignment_3()); }
	(rule__AttributesMapEntry__ValueAssignment_3)
	{ after(grammarAccess.getAttributesMapEntryAccess().getValueAssignment_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__Import__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__0__Impl
	rule__Import__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportAction_0()); }
	()
	{ after(grammarAccess.getImportAccess().getImportAction_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__1__Impl
	rule__Import__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportKeyword_1()); }
	'import'
	{ after(grammarAccess.getImportAccess().getImportKeyword_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__Import__Group__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getImportAccess().getImportURIAssignment_2()); }
	(rule__Import__ImportURIAssignment_2)
	{ after(grammarAccess.getImportAccess().getImportURIAssignment_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__0__Impl
	rule__EBigDecimal__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0()); }
	('-')?
	{ after(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__1__Impl
	rule__EBigDecimal__Group__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__2__Impl
	rule__EBigDecimal__Group__3
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getGroup_2()); }
	(rule__EBigDecimal__Group_2__0)?
	{ after(grammarAccess.getEBigDecimalAccess().getGroup_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__3
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group__3__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group__3__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getGroup_3()); }
	(rule__EBigDecimal__Group_3__0)?
	{ after(grammarAccess.getEBigDecimalAccess().getGroup_3()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group_2__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_2__0__Impl
	rule__EBigDecimal__Group_2__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0()); }
	'.'
	{ after(grammarAccess.getEBigDecimalAccess().getFullStopKeyword_2_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_2__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_2__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_2_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__EBigDecimal__Group_3__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__0__Impl
	rule__EBigDecimal__Group_3__1
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getAlternatives_3_0()); }
	(rule__EBigDecimal__Alternatives_3_0)
	{ after(grammarAccess.getEBigDecimalAccess().getAlternatives_3_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__1__Impl
	rule__EBigDecimal__Group_3__2
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1()); }
	('-')?
	{ after(grammarAccess.getEBigDecimalAccess().getHyphenMinusKeyword_3_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__2
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__EBigDecimal__Group_3__2__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__EBigDecimal__Group_3__2__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2()); }
	RULE_INT
	{ after(grammarAccess.getEBigDecimalAccess().getINTTerminalRuleCall_3_2()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__0__Impl
	rule__ResourceQualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
	(rule__ResourceQualifiedName__Group_1__0)?
	{ after(grammarAccess.getResourceQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceQualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__0__Impl
	rule__ResourceQualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getResourceQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceQualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceQualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
	ruleIID
	{ after(grammarAccess.getResourceQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceItemQualifiedName__Group__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceItemQualifiedName__Group__0__Impl
	rule__ResourceItemQualifiedName__Group__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_0()); }
	ruleIID
	{ after(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceItemQualifiedName__Group__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceItemQualifiedNameAccess().getGroup_1()); }
	(rule__ResourceItemQualifiedName__Group_1__0)?
	{ after(grammarAccess.getResourceItemQualifiedNameAccess().getGroup_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ResourceItemQualifiedName__Group_1__0
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceItemQualifiedName__Group_1__0__Impl
	rule__ResourceItemQualifiedName__Group_1__1
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group_1__0__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceItemQualifiedNameAccess().getFullStopKeyword_1_0()); }
	'.'
	{ after(grammarAccess.getResourceItemQualifiedNameAccess().getFullStopKeyword_1_0()); }
)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group_1__1
	@init {
		int stackSize = keepStackSize();
	}
:
	rule__ResourceItemQualifiedName__Group_1__1__Impl
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceItemQualifiedName__Group_1__1__Impl
	@init {
		int stackSize = keepStackSize();
	}
:
(
	{ before(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
	ruleIID
	{ after(grammarAccess.getResourceItemQualifiedNameAccess().getIIDParserRuleCall_1_1()); }
)
;
finally {
	restoreStackSize(stackSize);
}


rule__ActivityDispatching__ImportsAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityDispatchingAccess().getImportsImportParserRuleCall_1_0()); }
		ruleImport
		{ after(grammarAccess.getActivityDispatchingAccess().getImportsImportParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__NumberOfIterationsAssignment_2_2_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityDispatchingAccess().getNumberOfIterationsINTTerminalRuleCall_2_2_2_0()); }
		RULE_INT
		{ after(grammarAccess.getActivityDispatchingAccess().getNumberOfIterationsINTTerminalRuleCall_2_2_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__ResourceIterationsAssignment_2_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityDispatchingAccess().getResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0()); }
		ruleResourceIterationsMapEntry
		{ after(grammarAccess.getActivityDispatchingAccess().getResourceIterationsResourceIterationsMapEntryParserRuleCall_2_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ActivityDispatching__DispatchGroupsAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getActivityDispatchingAccess().getDispatchGroupsDispatchGroupParserRuleCall_3_0()); }
		ruleDispatchGroup
		{ after(grammarAccess.getActivityDispatchingAccess().getDispatchGroupsDispatchGroupParserRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__KeyAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getResourceIterationsMapEntryAccess().getKeyIResourceCrossReference_2_0()); }
		(
			{ before(grammarAccess.getResourceIterationsMapEntryAccess().getKeyIResourceResourceQualifiedNameParserRuleCall_2_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getResourceIterationsMapEntryAccess().getKeyIResourceResourceQualifiedNameParserRuleCall_2_0_1()); }
		)
		{ after(grammarAccess.getResourceIterationsMapEntryAccess().getKeyIResourceCrossReference_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceIterationsMapEntry__ValueAssignment_4
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getResourceIterationsMapEntryAccess().getValueINTTerminalRuleCall_4_0()); }
		RULE_INT
		{ after(grammarAccess.getResourceIterationsMapEntryAccess().getValueINTTerminalRuleCall_4_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__NameAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getNameIDStringParserRuleCall_2_0()); }
		ruleIDString
		{ after(grammarAccess.getDispatchGroupAccess().getNameIDStringParserRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__UserAttributesAssignment_3_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0()); }
		ruleAttributesMapEntry
		{ after(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__UserAttributesAssignment_3_1_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0()); }
		ruleAttributesMapEntry
		{ after(grammarAccess.getDispatchGroupAccess().getUserAttributesAttributesMapEntryParserRuleCall_3_1_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__IteratorNameAssignment_4_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getIteratorNameIDStringParserRuleCall_4_1_0()); }
		ruleIDString
		{ after(grammarAccess.getDispatchGroupAccess().getIteratorNameIDStringParserRuleCall_4_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__RepeatsAssignment_4_3_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getRepeatsNumberRepeatsParserRuleCall_4_3_0_0()); }
		ruleNumberRepeats
		{ after(grammarAccess.getDispatchGroupAccess().getRepeatsNumberRepeatsParserRuleCall_4_3_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__RepeatsAssignment_4_3_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_1_0()); }
		ruleRange
		{ after(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__RepeatsAssignment_4_3_1_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_2_1_0()); }
		ruleRange
		{ after(grammarAccess.getDispatchGroupAccess().getRepeatsRangeParserRuleCall_4_3_1_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__YieldAssignment_6_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getYieldINTTerminalRuleCall_6_2_0()); }
		RULE_INT
		{ after(grammarAccess.getDispatchGroupAccess().getYieldINTTerminalRuleCall_6_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__ResourceYieldAssignment_7
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getResourceYieldResourceYieldMapEntryParserRuleCall_7_0()); }
		ruleResourceYieldMapEntry
		{ after(grammarAccess.getDispatchGroupAccess().getResourceYieldResourceYieldMapEntryParserRuleCall_7_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__OffsetAssignment_8_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getOffsetEBigDecimalParserRuleCall_8_2_0()); }
		ruleEBigDecimal
		{ after(grammarAccess.getDispatchGroupAccess().getOffsetEBigDecimalParserRuleCall_8_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__DispatchGroup__DispatchesAssignment_9
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchGroupAccess().getDispatchesDispatchParserRuleCall_9_0()); }
		ruleDispatch
		{ after(grammarAccess.getDispatchGroupAccess().getDispatchesDispatchParserRuleCall_9_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__NumberRepeats__NumRepeatsAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getNumberRepeatsAccess().getNumRepeatsINTTerminalRuleCall_1_0()); }
		RULE_INT
		{ after(grammarAccess.getNumberRepeatsAccess().getNumRepeatsINTTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__StartAssignment_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_0_0()); }
		RULE_INT
		{ after(grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__StartAssignment_1_1_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_1_0_0()); }
		RULE_INT
		{ after(grammarAccess.getRangeAccess().getStartINTTerminalRuleCall_1_1_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Range__EndAssignment_1_1_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getRangeAccess().getEndINTTerminalRuleCall_1_1_2_0()); }
		RULE_INT
		{ after(grammarAccess.getRangeAccess().getEndINTTerminalRuleCall_1_1_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__KeyAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getResourceYieldMapEntryAccess().getKeyIResourceCrossReference_1_0()); }
		(
			{ before(grammarAccess.getResourceYieldMapEntryAccess().getKeyIResourceResourceQualifiedNameParserRuleCall_1_0_1()); }
			ruleResourceQualifiedName
			{ after(grammarAccess.getResourceYieldMapEntryAccess().getKeyIResourceResourceQualifiedNameParserRuleCall_1_0_1()); }
		)
		{ after(grammarAccess.getResourceYieldMapEntryAccess().getKeyIResourceCrossReference_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__ResourceYieldMapEntry__ValueAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getResourceYieldMapEntryAccess().getValueINTTerminalRuleCall_3_0()); }
		RULE_INT
		{ after(grammarAccess.getResourceYieldMapEntryAccess().getValueINTTerminalRuleCall_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Attribute__NameAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_1_0()); }
		RULE_ID
		{ after(grammarAccess.getAttributeAccess().getNameIDTerminalRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__ActivityAssignment_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getActivityActivityCrossReference_0_0()); }
		(
			{ before(grammarAccess.getDispatchAccess().getActivityActivityIDTerminalRuleCall_0_0_1()); }
			RULE_ID
			{ after(grammarAccess.getDispatchAccess().getActivityActivityIDTerminalRuleCall_0_0_1()); }
		)
		{ after(grammarAccess.getDispatchAccess().getActivityActivityCrossReference_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__ResourceItemsAssignment_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_1_0()); }
		(
			{ before(grammarAccess.getDispatchAccess().getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_1_0_1()); }
			ruleResourceItemQualifiedName
			{ after(grammarAccess.getDispatchAccess().getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_1_0_1()); }
		)
		{ after(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__ResourceItemsAssignment_1_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_2_1_0()); }
		(
			{ before(grammarAccess.getDispatchAccess().getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_2_1_0_1()); }
			ruleResourceItemQualifiedName
			{ after(grammarAccess.getDispatchAccess().getResourceItemsResourceItemResourceItemQualifiedNameParserRuleCall_1_2_1_0_1()); }
		)
		{ after(grammarAccess.getDispatchAccess().getResourceItemsResourceItemCrossReference_1_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__DescriptionAssignment_2_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getDescriptionSTRINGTerminalRuleCall_2_1_0()); }
		RULE_STRING
		{ after(grammarAccess.getDispatchAccess().getDescriptionSTRINGTerminalRuleCall_2_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__UserAttributesAssignment_2_2_0
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0()); }
		ruleAttributesMapEntry
		{ after(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_0_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Dispatch__UserAttributesAssignment_2_2_1_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0()); }
		ruleAttributesMapEntry
		{ after(grammarAccess.getDispatchAccess().getUserAttributesAttributesMapEntryParserRuleCall_2_2_1_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__KeyAssignment_1
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getKeyAttributeParserRuleCall_1_0()); }
		ruleAttribute
		{ after(grammarAccess.getAttributesMapEntryAccess().getKeyAttributeParserRuleCall_1_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__AttributesMapEntry__ValueAssignment_3
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getAttributesMapEntryAccess().getValueAlternatives_3_0()); }
		(rule__AttributesMapEntry__ValueAlternatives_3_0)
		{ after(grammarAccess.getAttributesMapEntryAccess().getValueAlternatives_3_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

rule__Import__ImportURIAssignment_2
	@init {
		int stackSize = keepStackSize();
	}
:
	(
		{ before(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_2_0()); }
		RULE_STRING
		{ after(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_2_0()); }
	)
;
finally {
	restoreStackSize(stackSize);
}

RULE_ID : '^'? ('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;

RULE_INT : ('0'..'9')+;

RULE_STRING : ('"' ('\\' .|~(('\\'|'"')))* '"'|'\'' ('\\' .|~(('\\'|'\'')))* '\'');

RULE_ML_COMMENT : '/*' ( options {greedy=false;} : . )*'*/';

RULE_SL_COMMENT : '//' ~(('\n'|'\r'))* ('\r'? '\n')?;

RULE_WS : (' '|'\t'|'\r'|'\n')+;

RULE_ANY_OTHER : .;
